﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows.Forms;

namespace ProjectMonorail
{
    public partial class FormMonorail : Form
    {
        private DrawningMonorail? _drawningMonorail;
        public FormMonorail()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawningMonorail == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxMonorail.Width, pictureBoxMonorail.Height);
            Graphics gr = Graphics.FromImage(bmp);
            _drawningMonorail.DrawTransport(gr);
            pictureBoxMonorail.Image = bmp;
        }
        private void buttonCreate_Click_1(object sender, EventArgs e)
        {
            Random random = new();
            _drawningMonorail = new DrawningMonorail();
            _drawningMonorail.Init(random.Next(100, 300), random.Next(1000, 3000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)), Convert.ToBoolean(random.Next(0, 2)));
            _drawningMonorail.SetPictureSize(pictureBoxMonorail.Width, pictureBoxMonorail.Height);
            _drawningMonorail.SetPosition(random.Next(10, 100), random.Next(10, 100));

            Draw();
        }
        private void ButtonMove_Click(object sender, EventArgs e)
        {
            if (_drawningMonorail == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            bool result = false;
            switch (name)
            {
                case "buttonUp":
                    result =
                    _drawningMonorail.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    result =
                    _drawningMonorail.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    result =
                    _drawningMonorail.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    result =
                    _drawningMonorail.MoveTransport(DirectionType.Right);
                    break;
            }
            if (result)
            {
                Draw();
            }
        }

        
    }
}


